//
// To compile in Visual Studio 2022 (free Community Edition): 
//   1) Create a new Dynamic Link Library project
//   2) Copy this .c file into the Project Directory that was created in #1 above
//   3) Remove all other Source Files added by #1 above (dllmain.cpp, psh.h, etc.)
//   4) Use Project -> Add Existing Item to select and add this .c file to the Source Files
//   5) Change Active Solution Platform from x64 to x86 in Configuration Manager
//   6) turn off the Use Precompiled Headers option in Project -> "ProjectName" Properties -> C/C++ -> Precompiled Heading section -> Precompiled Header -> Not Using Precompiled Headers
//   7) Choose Build Solution
//   8) .dll file compiled into \debug project directory will need to be copied to C:\NeuroShell Trader\Template directory
//      for the .dll file to be seen/used by a NeuroShell Trader chart.
//

#include <windows.h>   
#include <math.h>   

const float MISSING = (float) 3.4e38;    // NeuroShell Trader missing value constant

_declspec(dllexport) void DynamicExpAvg(float* Close, float *Multiplier, long numrows, float* output)
{	// The Elegant Oscillator
	// (c)2021 John F.Ehlers

	double ExpAvg;
	long Currentbar;

	for (Currentbar = 0; Currentbar < numrows; Currentbar++)  
	{
		if (Currentbar == 0)
			ExpAvg = Close[Currentbar];
		else
			ExpAvg = ExpAvg * (1 - Multiplier[Currentbar]) + Multiplier[Currentbar] * Close[Currentbar];
		
		output[Currentbar] = (float)ExpAvg;
	}
}